#ifndef __tshar_h__
#define __tshar_h__



#if !defined AVR
#define NPRGPATH 8	// Number of program pathes
#else
// #define NPRGPATH 4	// Number of program pathes in avrbats/makedefs / avr/ccs.bat file
#endif


#ifdef AVR
FUNCT void tseinri_P(			// add a function to the list of functions to run
					int index,
					void (*funaddr)(),
					void *stackbase,
					int stacksize);
#define tseinri(i,f,p,s,z) tseinri_P(i,f,s,z)
#else
FUNCT int tseinri(			// add a function to the list of functions to run
					int index,
					void (*funaddr)(),
					char *pname,
					void *stackbase,
					int stacksize);
#endif



#ifdef AVR
FUNCT void tsnext_P( void );	// Debug info: a fixed string
#define tsnext(x) tsnext_P()
#else
FUNCT void tsnext( const char *where); // Debug info: a fixed string
#endif


FUNCT int tsgetlin(		// Read a line from the console (vt)
	char *pb,
	int max_len );

FUNCT void tsopen(void);		// clear all tables

extern const char *tsnext_p[NPRGPATH] ;
extern const char *proces_p[NPRGPATH] ;

extern void (*outfun[NPRGPATH])(const char c);

extern int tshar_task_no ;					// task index, 0=the task in the main() loop

// Which character input / character output / the task tshar_task_no has to use
extern void (*vout_char[NPRGPATH])(const uchar c);
// Send a character to the terminal
// here for each task the output routine has to be set, e.g. the addresse of out_char or tslcd_ocha
// call just out_char to send a character

extern uchar (*vin_char[NPRGPATH])(void);
// here for each task the input routine has to be set, e.g. the addresse of in_char
// call just in_char to get a character

extern bool (*vin_check[NPRGPATH])(void);
// here for each task the input check routine has to be set, e.g. the addresse of in_check
// call just in_check to check if there is a character available


#endif // __tshar_h__
