
; .include "c:/home/cc/include/longbr.inc"
.include "../../../include/longbr.inc"

; Author : HJHerbert (2007-02-07)
; HJHerbert 2007-04-15 : still some last bit rounding differences on normal results (random)
;
; float fa = -17.444;
; float fb = 306.2;
; ...
; hr1 = fa * fb ;
;
; needs 150 cycles = 9.375 usec at 16 MHz
; The original library routine needed 2059 cycles, 128.6875 usec
;
; Arithmetic Errors: less than 0.2 ppm of result
;
; Hint: because the mantissa is between 0.5 and ca. 0.999xxx
; the multiplication result is betweeen 0.25 and 0.999xxx
; Therefore after b multiplication no full narmalisation is neccesary
; Just to check if b single shift is neccesary or not.
;
; It is just b interpretation if the mantissa is to be considered 
; as  to be in the range 1.0 to 1.999xxx (hence the exponent offset is 127)
; or see the mantissa as 0.5 to 0.999xxx (hence the exponent offset is 126)
; the code and the numbers are the same!
;
	.data

	.text

; hr = ha * hb
; (See also /home/html/hjh/atmel/lib/float.htm)
; Input : 
; r21 r20 r19 r18 = The first argument
; r25 r24 r23 r22 = a the second (IEEE)
; Output :
; r25 r24 r25 r24 = a The result, (IEEE)
; used registers
; r9 r8 r7 r6 : The new mantissa (32 bit, the least 8 bits will be ignored on return
; r5 = 0 (because r0 is used by CPU)


	round = 1 			; disable (0) or enable (1) rounding
	nan_support = 1		; disable (0) or enable (1) nan input support
	denorm_support = 1	;
	negative_0_support = 1	

;
	.extern	__normsf3
 	.global __mulsf3
__mulsf3:
 ;	push	r0	; avr-gcc convention r0 = temporary
	push	r5
 	push	r6
 	push	r7
 	push	r8
 	push	r9
	push	r28
	push	r27
 	push	r26
 	push	r18
 	push	r19
 	push	r20
 	push	r21



; Have first Argument      (a) in r25 r24 r23 r22
; may be +Inf , -Inf or a valid number (including special 0.000)
; Have the second argument (b) in r21 r20 r19 r18

; unpack the exponent of b to r8 and mantissa of b to r20 r19 r18
	add	r20,r20	; Bit 7 = lowest bit of exponend b to carry
	mov	r28,r21 	; Bit 6...0 = Bit 7...1 of exponent b
	adc	r28,r28 	; r28 = exp b


.if denorm_support
	or	r28,r28		; If the exp b
	brne	m23b_1
	; r28 = 0
	inc	r28		; because exp b == 0 : correct exponent (r28=1, Carry=0)
	clc
	rjmp	m23b_0
m23b_1:
.endif
	sec			; Set Carry = M23
.if denorm_support
m23b_0:
.endif
	ror	r20		; r20 M22..M17

; r21 sign of b
; r27 8 bits exp b
; r20 r19 r18 mantissa of b (with bit 7 of r20=1)

; unpack the exponent of a to r26 and mantissa of a to r24r23r22
	add	r24,r24	; -> Carry
	mov	r26,r25 	; Bit 6...0 = Bit 7...1 of exponent a
	adc	r26,r26	; r26 = exp a

; r21 sign of b
; r27 8 bits exp b
; r20 r19 r18 mantissa of b (with bit 7 of r24=1)


.if denorm_support
	or	r26,r26		; If the exp a
	brne	m23a_1
	; r26 = 0
	inc	r26		; correct exponent (r26=1, Carry=0)
	clc
	rjmp	m23a_0
m23a_1:
.endif
	sec			; Set Carry = M23
.if denorm_support
m23a_0:
.endif
	ror	r24		; r24 Mb22..Mb17 a

	cpi	r26,0xff	; if EXP a == FF
	breq	NaN_or_Inf_a
	cpi	r28,0xff	; if EXP b == FF
	breq	NaN_or_Inf_b
	rjmp	both_normal


NaN_or_Inf_a:	; r26 = FF Check if it is NaN or +-Inf
; exp a is FF, a is either Inf or NaN
	mov	r27,r24
	andi	r27,0x7F
	or	r27,r23
	or	r27,r22
	brne	return_nan		; a = NaN
; a is +/-Inf

	mov	r27,r18		; Check Mantissa b
	or	r27,r19
	or	r27,r20
	breq	return_nan		; +/-Inf * 0 = NaN
	
	cpi	r28,0xff		; if EXP b == FF
	brne	joverflow		; a is +-Inf, b is a valid number
	
	mov	r27,r20		; Check mantissa b
	andi	r27,0x7F
	or	r27,r19
	or	r27,r18
	brne	return_nan		; a is +/-Inf and b is NaN
; a is +/-Inf and b is +/-inf

;	mov	r27,r21
;	eor	r27,r25
;	brmi	return_nan		; a is +/-Inf and b is -/+Inf
	
joverflow:
	rjmp	overflow		; sign is r25 ^ r21

	
NaN_or_Inf_b:
; exp b is FF, exp a is not FF
	mov	r27,r20		; CHeck if b is Nan
	andi	r27,0x7F
	or	r27,r19
	or	r27,r18
	brne	return_nan
; b is +/- Inf
	mov	r27,r22		; M a
	or	r27,r23
	or	r27,r24
	brne	joverflow	; sign is r25 ^ r21
; 0 * +/-Inf = NaN



return_nan:
	ldi	r22,0
	ldi	r23,0
	ldi	r24,0xC0
	ldi	r25,0x7F
; r25 sign of result
; r26 8 bits exp a of result
; r24 r23 r22 mantissa of result (with bit 7 of r24=1)
	rjmp	mulreturn



; r25 sign of a (and parts of the old exponent)
; r26 8 bits exp a
; r24 r23 r22 mantissa of a (with bit 7 of r24=1)


both_normal:
	eor	r5,r5
	
; calculate the exponent
	eor	r27,r27		; Result exponent extension, exponent of result = r27 r26
	add	r26,r28		; Add exponents 1...254 + 1..254 = 2..508
	adc	r27,r5		; extension r27:r26 = 9 bit exponent
	subi	r26,0x7E		; subtract defined offset 0x7E = 254, 2..508-254 = -252..254
	sbc	r27,r5		; r5=0 r27:r26 is the exponent

; Check if need to shift from subnormals
.if denorm_support
	or	r20,r20
	brne	bn20
	or	r19,r19
	brne	bn19
	sbiw	r26,16
	mov	r20,r18
	eor	r19,r19
	eor	r18,r18
	rjmp	bn20
bn19:
	sbiw	r26,8
	mov	r20,r19
	mov	r19,r18
	eor	r18,r18
bn20:

	or	r24,r24
	brne	bn24
	or	r23,r23
	brne	bn23
	sbiw	r26,16
	mov	r24,r22
	eor	r23,r23
	eor	r22,r22
	rjmp	bn24
bn23:
	sbiw	r26,8
	mov	r24,r23
	mov	r23,r22
	eor	r22,r22
bn24:


.endif

; Perform unsigned mutiplication and add to
;     r20         r19         r18
;r24  A B         B C         C D
;r23  B C         C D         D E
;r22  C D         D E         E F
; each mul result will be in r1 r0
; need to keep A B C for result, D for rounding, no need to keep and calculate E F
; A B C D = r9 r8 r7 r6


	mul	r24,r20	; A B = r24*r20
	movw	r8,r0

	mul	r23,r19	; C D = r23*r19
	movw	r6,r0

	mul	r24,r19	; B C += r24*r19
	add	r7,r0
	adc	r8,r1
	adc	r9,r5

	mul	r23,r20	; B C += r23*r20
	add	r7,r0
	adc	r8,r1
	adc	r9,r5

	mul	r22,r20	; C D += r22*r20
	add	r6,r0
	adc	r7,r1
	adc	r8,r5
	adc	r9,r5

	mul	r24,r18	; C D += r22*r20
	add	r6,r0
	adc	r7,r1
	adc	r8,r5
	adc	r9,r5

	mul	r22,r19	; D E += r22*r19
	adc	r6,r1
	adc	r7,r5
	adc	r8,r5
	adc	r9,r5

	mul	r23,r18	; D E += r23*r18
	adc	r6,r1
	adc	r7,r5
	adc	r8,r5
	adc	r9,r5
	eor	r1,r1
; The multiplication is done, its result is in r9:r8:r7:r6
; We can use r18,r19,r20 for any storage	
; r27:r26 is the exponent
 	.global __mulsf3_mul_done
__mulsf3_mul_done:

	rcall	__normsf3

mulreturn:
; r25 = s, exp7..exp1
; r24 = exp0, M22..M16
; r25 = M15..M8
; r24 = M7..M0
	pop	r26
	pop	r27
	pop	r28
	pop	r21
	pop	r20
	pop	r19
	pop	r18
	pop	r9
	pop	r8
	pop	r7
	pop	r6
	pop	r5
	eor	r1,r1	; avr-gcc convention r1=0
;	pop	r0	; avr-gcc convention r0 = temporary
	.global	mulret
mulret:
	ret

overflow:
	eor	r25,r21	; sign = sign ^ sign b
	ldi	r22,0
	ldi	r23,0
	ldi	r24,0x80
	ori	r25,0x7f	; exp7..exp1
	rjmp	mulreturn
