
#include <heport.h>
#include <helq.h>


/* ---------------------------------------------------------- */
/*
ASCII to single character

Allowed forms are:
"x"   = 'x'
'x'   = 'x'
\101  = 'A'
g     = 'g'
 */
FUNCT int asctochar(	 // get one character
const char **plst ,		// String-pointer
char *pc )				// where to save the character
{
skipwhite( *plst );
char zch ;
char oct ;
int i ;


if ( **plst == 0 ) return 2 ;
zch = *(*plst)++ ;
if ( zch == '\042' )		// "x"
	{
	zch = *(*plst)++ ;
	if ( zch == 0 ) return E 2 ;
	if ( *(*plst)++ != '\042' ) return E 2 ;
	*pc = zch ;
	return 0 ;
	}
if ( zch == '\047' )		// 'x'
	{
	zch = *(*plst)++ ;
	if ( zch == 0 ) return E 2 ;
	if ( *(*plst)++ != '\047' ) return E 2 ;
	*pc = zch ;
	return 0 ;
	}
if ( zch == '\\' )		// \012
	{
	zch = **plst ;
	if ( zch >= '0' && zch < '8' )
		{
		oct = 0 ;
		for ( i = 0 ; i < 3 ; ++i )
			{
			zch = *(*plst)++ ;
			if ( zch >= '0' && zch < '8' )
				{
				oct <<= 3 ;
				oct += zch - '0' ;
				}
			else
				{
				return E 2 ;
				}
			}
		*pc = oct ;
		return 0 ;
		}
	else		// \t \l \r \n
		{
		if ( zch == 't' )
			{
			*pc = '\t' ;
			++(*plst) ;
			return 0 ;
			}
		if ( zch == 'l' )
			{
			*pc = 012 ;
			++(*plst) ;
			return 0 ;
			}
		if ( zch == 'r' )
			{
			*pc = 015 ;
			++(*plst) ;
			return 0 ;
			}
		if ( zch == 'n' )
			{
			*pc = '\n' ;
			++(*plst) ;
			return 0 ;
			}
		if ( zch == '^' )
			{
			*pc = '^' ;
			++(*plst) ;
			return 0 ;
			}
		if ( zch == '\\' )		// Sequence \\ returns as \ .
			{
			*pc = '\\' ;
			++(*plst) ;
			return 0 ;
			}
		return E 2 ;
		}
	return E 2 ;
	}
if ( zch == '^' )		// Control characters
	{
	zch = **plst ;
	if ( zch >= 'a' && zch <= 'z' )
		{
		*pc = zch - 0x60 ;
		++(*plst) ;
		return 0 ;
		}
	if ( zch >= 'A' && zch <= 'Z' )
		{
		*pc = zch - 0x40 ;
		++(*plst) ;
		return 0 ;
		}
	return E 2 ;
	}
*pc = zch ;
return 0 ;
}		/* end asctochar() */
