
#include <heport.h>
#include <helq.h>
#include <hegettim.h>


/* ---------------------------------------------------------- */
/*
ASCII to Time epoch time Token string
 */
FUNCT int asctotim(		// get token, either numeric or alphabetic
const char **ppc ,		// String-pointer
CEpoch *pdate )			// where to save the time value
// Return value :
// 0 full date has been given as "2002.05.30 8:40" or "2002.05.30 8:42:23"
//							  or "2002.05.30/8:42:23"
//							  or "2002-05-30/8:42:23"
//							  or "2002-05-30 8:42:23"
// 1 only time has been given as "8:40" or "8:42:23"
// 1 may be interpreted as "dayly"
// 20 : Bad value
// 21 : unexpected terminator
{
int j ;
uint nums[6] ;
const char *lst ;
int rv ;
rv = 0 ;

#define YEAR nums[0]
#define MONTH nums[1]
#define DAY nums[2]
#define HOUR nums[3]
#define MINUTE nums[4]
#define SECOND nums[5]


lst = *ppc ;
nums[0] = 0 ;
nums[1] = 0 ;
nums[2] = 0 ;
nums[3] = 0 ;
nums[4] = 0 ;
nums[5] = 0 ;
for ( j = 0 ; j < 6 ; ++j )
	{
//	  uchar			  knz ;		   // Flag: digits are detected
	register uword	  zzz ;

	zzz = 0 ;
//	  knz = 0 ;

	skipwhite( lst );

	while ( *lst >= '0' && *lst < '9'+1 )
		{
		// knz = 1 ;
		if ( zzz <= 6552 )
			{
			if ( zzz == 6553 && *lst > '5' )
				{
				*ppc = lst ;	// give rest of string back to caller
				return 20 ;		// Value error
				}
			zzz = zzz * 10 + *lst - '0' ;
			}
		else		// Number too big
			{
			*ppc = lst ;	// give rest of string back to caller
			return 2 ;		// number too big
			}
		++lst ;
		}
	// *lst is the separator
	if ( *lst == ':' && j == 0 )
		{					// We have only time, no date
		rv = 1 ;
		j = 3 ;				// Index of HOUR in nums[]
		}
	nums[j] = zzz ;
	if ( j == 5 ) break ;	// all done
	if (	 ( ( *lst == '.' || *lst == '-' ) && j == 0 )		// list of correct delimiters
		  || ( ( *lst == '.' || *lst == '-' ) && j == 1 )
		  || ( ( *lst == ' ' || *lst == '/' ) && j == 2 )
		  || ( *lst == ':' && j == 3 )
		  || ( *lst == ':' && j == 4 ) )
		{
		++lst ;
		continue ;
		}
	if ( ( *lst == ',' || *lst == 0 || *lst == '\n' ) && j == 4 ) break ;
	*ppc = lst ;	// give rest of string back to caller
	return 21 ;
	}
if ( rv == 0 )
	{
	*pdate = CEpoch( YEAR, MONTH, DAY, HOUR, MINUTE, SECOND );
	}
else		// rv == 1 , dayly
	{
	*pdate = (ulong)HOUR * 3600L + (ulong)MINUTE * 60L + (ulong)SECOND ;
	}


*ppc = lst ;	// give rest of string back to caller
return rv ;
}		/* end asctotok() */
