#include <heport.h>
// #include <helq.h>
#include <hegettim.h>		// TImer handling getticks(), difftick()
#include <tshar.h>			// Timesharing: tsnext()


FUNCT void delaytick( ulong demandtick )
// wait n ticks, call tsnext while waiting
{
ulong starttick ;

starttick = gettick();          // Start of delay loop
while ( difftick( starttick, gettick() ) <= demandtick + 1 )
	{
	tsnext("delaytick");		// Keep the timesharing running!
	}
// Has wait the requested time (and maybe a bit more)
return ;
}


/* Error consideration

Tick : +------------------+------------------+------------------+------------------+
B:     | ^                                  ^
C:     |                 ^ ^ 
want 1 : 0                ,1                  ,2
B: t= 1.9 Ticks, difftick() = 1 worst highest case
C: t= 0.1 Ticks, difftick() = 1 worst lowest case

The return error of difftick is between -0.999 and +0.999

Because delaytick should never delay less that specified, we need to add 1 to demandtick
Then delaytick will delay from difftick (at least) up to difftick+1.999

Then still there will be some additional delay caused by delays in 
call / entry / return and for the time tsnext() can use.

msectotick() and sectotick() is always rounding up!


If you need more precision on a AVR, then use a lower timer divisor (perhaps use /1 and the 16 bit timer 1)
see makedefs: filename=  /home/cc/avrbat/makedefs

GETTICK_TIMER=1
AVR_TIMER_DIVIDER_CODE=1

*/
