
#include <heport.h>
#include <heimath.h>
#ifdef AVR
#include <avr/io.h>
#endif



#ifndef AVR
FUNCT slong mul_sw_sw( sword x , sword y )
{
slong res ;

res = (slong)x * (slong)y ;
return res ;
}

#else

// input:
// r23_r22 = x.h_x.l
// r25_r24 = y.h_y.l
// return r25_r24_r23_r22

FUNCT slong dummy_mul_sw_sw( sword x , sword y )
{

// asm(" .text " "\n");
asm(" ; " "\n");
asm("  .global mul_sw_sw" "\n");
asm(" ; See as well mul_sc_sc : 8 bit by 8 bit, result 16 bits " "\n");
asm(" ; " "\n");
asm(" ; Function mul_sw_sw " "\n");
asm(" ; multiply signed 16 bit by 16 bit " "\n");
asm(" ; " "\n");
asm(" ; Input: " "\n");
asm(" ;     r23:r22   : The factor " "\n");
asm(" ;     r25:r24   : The factor " "\n");
asm(" ; Results " "\n");
asm(" ;     r25:r24:r23:r22    : result " "\n");
asm(" ; Destroyed registers " "\n");
asm(" ;     r18 r19 r20 r21 r26 r27" "\n");
asm(" ; This program is verified by qqtsser.asm " "\n");
asm(" ; " "\n");
asm("mul_sw_sw: " "\n");
asm(" 	push r16 ; " "\n");
asm("	clr	r16" "\n" );
asm("	clr	r1" "\n" );
asm(" 	or	r23,r23 ; Check sign" "\n");
asm(" 	brpl	mul_sw_sw_1 " "\n" );
asm(" 	inc	r16	; toggle bit 0" "\n");
asm("	com	r23 " "\n" );
asm("	com	r22 " "\n" );
asm(" 	sec ; Set carry flag" "\n" );
asm(" 	adc r22,r1 ; r22 = r22 + 0 + 1" "\n" );
asm(" 	adc r23,r1 ; r23 = r23 + 0 + cy" "\n" );
asm("mul_sw_sw_1: " "\n");
asm(" 	or	r25,r25 ; Check sign" "\n");
asm(" 	brpl	mul_sw_sw_2 " "\n" );
asm(" 	inc	r16	; toggle bit 0" "\n");
asm("	com	r25 " "\n" );
asm("	com	r24 " "\n" );
asm(" 	sec ; Set carry flag" "\n" );
asm(" 	adc r24,r1 ; r24 = r24 + 0 + 1" "\n" );
asm(" 	adc r25,r1 ; r25 = r25 + 0 + cy" "\n" );
asm("mul_sw_sw_2: " "\n");
asm(" 	rcall 	mul_uw_uw " "\n" );
asm(" 	bst	r16,0 ; Store the Bit 0 of r16 into T flag" "\n");
asm(" 	brtc mul_sw_sw_3 ; Check T flag" "\n");
asm(" ; negate result r25:r24;r23;r22 " "\n");
asm(" 	com r25 " "\n");
asm(" 	com r24 " "\n");
asm(" 	com r23 " "\n");
asm(" 	com r22 " "\n");
asm(" 	sec ; Set carry flag" "\n" );
asm(" 	adc r22,r1 ; r22 = r22 + 0 + 1" "\n" );
asm(" 	adc r23,r1 ; r23 = r23 + 0 + cy" "\n" );
asm(" 	adc r24,r1 " "\n");
asm(" 	adc r25,r1 " "\n");
asm(" ; " "\n");
asm(" mul_sw_sw_3: " "\n");
asm(" ; result is 32 bits in r25:r24:r23:r22 " "\n");
asm(" 	eor	r1,r1 " "\n");
asm(" 	pop	r16 " "\n");
asm(" 	ret " "\n");

return 0 ;
}
#endif
