#include <heport.h>
#include <hegettim.h>

#ifdef AVR
#include <avr/io.h>
#include <avr/pgmspace.h>
#endif

ulong starttick_tsdaytim ;
ulong starttick_getmsec ;
ulong g_msec ;				// The global Milliseconds counter

struct sdate_uc date_uc ;		// Keep seconds, minutes, hours running here in



FUNCT void tsdaytim(void)
// Keep the time-of-the-day actual
// Add a second, if a second if gone
{
if ( gettick() - starttick_tsdaytim > TICKPERSEC )
	{		// once per second
	if ( ++date_uc.second >= 60 )
		{
		date_uc.second = 0 ;
		if ( ++date_uc.minute >= 60 )
			{
			date_uc.minute = 0 ;
			if ( ++date_uc.hour >= 24 )
				{
				date_uc.hour = 0 ;
				++date_uc.day ;
				}
			}
		}
	starttick_tsdaytim = addtick(starttick_tsdaytim ,TICKPERSEC ); // Wait for next second
	}

while ( gettick() - starttick_getmsec > TICKPERMSEC )
	{
	++g_msec ;
	starttick_getmsec += TICKPERMSEC ;
	}

}


FUNCT void tsdaytim_open(void )
{
#ifndef AVR
struct sdate vdate ;
struct sday vday ;		// The time from operationg system

getutcdatetime( &vdate, &vday );
date_uc.second = vday.second ;
date_uc.minute = vday.minute ;
date_uc.hour   = vday.hour ;

#endif

tickopen();			// initialze timer
starttick_getmsec = starttick_tsdaytim = gettick();

}
