' note: All print results go to the logging file and can be examinated e.g. by the Programmers Notepad pn.exe
' note: the language used here is described in 
'       file:///C:/HOME/html/hjh/cc/english/util/simbase.htm
'       file:///C:/HOME/html/hjh/cc/deutsch/util/simbase.htm
'
float ftw[20]
uint32_t ultw
float bha
float bhb
float bhr
float bexpect
float bresult
uint32_t ix
uint32_t jx
uint32_t nx
uint32_t oldcy
uint32_t maxcy				' The slowest combination has the maximum cycle time
uint32_t mincy
uint32_t sumcy 
uint32_t ncy 
uint32_t pcstart

uint32_t failures			' counts how many failures
uint32_t tests				' counts how many tests have been performed
uint8_t result_nan			' The result is NaN
uint8_t expect_nan			' The expect is NaN
uint16_t testfun
uint16_t stackstart

uint8_t denorm_supp			' 0 = treat all denormalized numbers as = 0

denorm_supp = 1


testfun = call_divsf3		' Select HERE what to test today by f2 __addsf3 or __mulsf3
bp call_addsf3+2			' See a call can be a one word instruction for AT8535 
bp call_mulsf3+2			' or a two word instruction as for ATmega32
bp call_divsf3+2			' Because behind the call there is a nop, this is always the after the funktion

stackstart = _end+50		' This is good for any processor with memory
bha = 3.0
bhb = 6.2
f18=bhb
f22=bha
pc=pcstart 					' Set next instruction
sp=stackstart				' preset stack pointer


gosub f1					' Display the help
end
stop




' ****************************************************************************
label f2 ' Can come here with Function Key f2

tests = 0 : failures = 0 : mincy = 300000 : maxcy = 0 : sumcy = 0 : ncy = 0 


if testfun == call_addsf3 then gosub testalladd	' The special patterns
if testfun == call_mulsf3 then gosub testallmul
if testfun == call_divsf3 then gosub testalldiv



if testfun == call_addsf3 then print "Check addsf3"
if testfun == call_mulsf3 then print "Check mulsf3"
if testfun == call_divsf3 then print "Check divsf3"
print "Summary special tests", tests, "failures : ", failures, " Cycles mincy=", mincy, " maxcy=", maxcy, " mean=", sumcy/ncy

' The special patterns have been performed

tests = 0 : failures = 0 : mincy = 300000 : maxcy = 0 : sumcy = 0 : ncy = 0 
ix = 0

' Random Test with 32 bit random patterns
label nexti2
hr1.l = lprbs() : bha = hr1.f
hr1.l = lprbs() : bhb = hr1.f
gosub f9
ix = ix + 1
if ix < 2000 then goto nexti2


if testfun == call_addsf3 then print "Check addsf3"
if testfun == call_mulsf3 then print "Check mulsf3"
if testfun == call_divsf3 then print "Check divsf3"
print "Summary random tests lprbs ", tests, "failures : ", failures, " Cycles mincy=", mincy, " maxcy=", maxcy, " mean=", sumcy/ncy


' Random Test with float random patterns
tests = 0 : failures = 0 : mincy = 300000 : maxcy = 0 : sumcy = 0 : ncy = 0 
ix = 0
label nexti3
bha = lprbs()/4294967296.
bhb = lprbs()/4294967296.
gosub f9
ix = ix + 1
if ix < 500 then goto nexti3


if testfun == call_addsf3 then print "Check addsf3"
if testfun == call_mulsf3 then print "Check mulsf3"
if testfun == call_divsf3 then print "Check divsf3"


print "Summary random tests dprbs", tests, "failures : ", failures, " Cycles mincy=", mincy, " maxcy=", maxcy, " mean=", sumcy/ncy
return


' ****************************************************************************
label f3
p "Test addsf3"
testfun = call_addsf3		' Select HERE what to test today __addsf3 or __mulsf3
gosub f2
p "Test mulsf3"
testfun = call_mulsf3		' Select HERE what to test today __addsf3 or __mulsf3
gosub f2
p "Test divsf3"
testfun = call_divsf3		' Select HERE what to test today __addsf3 or __mulsf3
gosub f2
return 


' ****************************************************************************

label testalladd
' for addition
ftw[ 0] = 0x7FC00000.f
ftw[ 1] = 0x7F800000.f
ftw[ 3] = 0x3F800000.f
ftw[ 4] = 0x3F000000.f
ftw[ 5] = 0x00000000.f
ftw[ 6] = 0x00800000.f ' The lowest non zero not denormalized
ftw[ 7] = 0x00002000.f ' denormalized
ftw[ 8] = 0x00002000.f ' denormalized
ftw[ 9] = 0x007fffff.f ' denormalized
ftw[10] = 0x7F7fffff.f ' The biggest
ftw[11] = 0x7F7ffffe.f ' The biggest minus a tick
ftw[12] = 0x72800000.f '
ftw[13] = 0x73000000.f '
ftw[14] = 0x73800000.f '
ftw[15] = 0x00005000.f ' denormalized
ftw[16] = 0x00000002.f ' denormalized
ftw[17] = 0x00000002.f ' denormalized

nx = 18
gosub testallftw

return






' ****************************************************************************
label testallmul

bha=1.0   : bhb=3.0 : gosub f9
bha=3.0   : bhb=6.0 : gosub f9
bha=1.6   : bhb=0x00000001.f : gosub f9
bha=1.6   : bhb=0x00000002.f : gosub f9
bha=1.6   : bhb=0x00000003.f : gosub f9
bha=1.5   : bhb=0x00000001.f : gosub f9
bha=1.5   : bhb=0x00000002.f : gosub f9
bha=1.5   : bhb=0x00000003.f : gosub f9
bha=1.5   : bhb=0x00000004.f : gosub f9
bha=1.4   : bhb=0x00000001.f : gosub f9
bha=1.4   : bhb=0x00000002.f : gosub f9
bha=1.4   : bhb=0x00000003.f : gosub f9
bha=0.25  : bhb=0x00000001.f : gosub f9
bha=0.5   : bhb=0x00000001.f : gosub f9
bha=0.75  : bhb=0x00000001.f : gosub f9
bha=1.0   : bhb=0x00000001.f : gosub f9
bha=1.2E8 : bhb=0x00000001.f : gosub f9
bha=1.2E8 : bhb=0x007fffff.f : gosub f9
bha=31.0  : bhb=0x01003031.f : gosub f9
bha=1.0   : bhb=0x00000001.f : gosub f9
' for multiplication
ftw[ 0] = 0x7FC00000.f
ftw[ 1] = 0x7F800000.f
ftw[ 2] = 0x1F830000.f
ftw[ 3] = 0x1F030000.f
ftw[ 4] = 0x20030000.f
ftw[ 5] = 0x7F7fffff.f ' The biggest
ftw[ 6] = 0x7F7ffffe.f ' The biggest minus a tick
ftw[ 7] = 0x72800000.f '
ftw[ 8] = 0x73000000.f '
ftw[ 9] = 0x73800000.f '
ftw[10] = 0x00005000.f ' denormalized
ftw[11] = 0x00000002.f ' denormalized
ftw[12] = 0x00000001.f ' denormalized
ftw[13] = 0x60030000.f
ftw[14] = 0x5f036000.f
ftw[15] = 0x00000000.f
nx = 16
gosub testallftw
return



' ****************************************************************************
label testalldiv

bha=12.64655 : bhb=12.64122 : gosub f9
bha=12.64122 : bhb=12.64655 : gosub f9
bha=1.0   : bhb=3.0 : gosub f9
bha=300.0   : bhb=3.0 : gosub f9
bha=1.5   : bhb=0x00000001.f : gosub f9
bha=1.5   : bhb=0x00000002.f : gosub f9
bha=1.5   : bhb=0x00000003.f : gosub f9
bha=1.4   : bhb=0x00000001.f : gosub f9
bha=1.4   : bhb=0x00000002.f : gosub f9
bha=1.4   : bhb=0x00000003.f : gosub f9
bha=1.0   : bhb=0x00000001.f : gosub f9
' for division
ftw[ 0] = 0x7FC00000.f
ftw[ 1] = 0x7F800000.f
ftw[ 2] = 0x1F830000.f
ftw[ 3] = 0x1F030000.f
ftw[ 4] = 0x20030000.f
ftw[ 5] = 0x7F7fffff.f ' The biggest
ftw[ 6] = 0x7F7ffffe.f ' The biggest minus a tick
ftw[ 7] = 0x72800000.f '
ftw[ 8] = 0x73000000.f '
ftw[ 9] = 0x73800000.f '
ftw[10] = 0x00005000.f ' denormalized
ftw[11] = 0x00000002.f ' denormalized
ftw[12] = 0x00000002.f ' denormalized
ftw[13] = 0x60030000.f
ftw[14] = 0x5f036000.f
nx = 15
gosub testallftw
return


' --------------------------------------------
label testallftw

ix = 0 
label nexti
jx = 0
label nextj

bha=ftw[ix]
bhb=ftw[jx]
gosub f9
bha=-ftw[ix]
bhb=ftw[jx]
gosub f9
bha=ftw[ix]
bhb=-ftw[jx]
gosub f9
bha=-ftw[ix]
bhb=-ftw[jx]
gosub f9

bhb=ftw[ix]
bha=ftw[jx]
gosub f9
bhb=-ftw[ix]
bha=ftw[jx]
gosub f9
bhb=ftw[ix]
bha=-ftw[jx]
gosub f9
bhb=-ftw[ix]
bha=-ftw[jx]
gosub f9

jx = jx + 1
if jx < nx then goto nextj
ix = ix + 1
if ix < nx then goto nexti
return





' ****************************************************************************
' The subroutine which performes a single bha # bhb test
label f9
print
print
if testfun == call_addsf3 then bexpect=bha+bhb : print "Check addsf3"
if testfun == call_mulsf3 then bexpect=bha*bhb : print "Check mulsf3"
if testfun == call_divsf3 then bexpect=bha/bhb : print "Check divsf3"
pcstart=testfun
tests = tests + 1
print "testcase ",bha,bhb,hex$(bha),hex$(bhb)

f18=bhb
f22=bha
pc=pcstart ' Set next instruction
sp=stackstart	' preset stack pointer

oldcy = cy
execute
' The target program __addsf3 __divfs3 __mulsf3 did return to call_addsf3+2 call_mulsf3+2 call_divsf3+2

bresult=f22						' get the result from r35:r34:r23:r22
print "used cycles=", cy-oldcy
sumcy = sumcy + cy - oldcy
ncy = ncy + 1
if cy - oldcy > maxcy then maxcy = cy-oldcy
if cy - oldcy < mincy then mincy = cy-oldcy
print "result=",bresult,hex$(bresult),"expect=",bexpect,hex$(bexpect)
if bresult == bexpect then return	' The Atmel simulator simatmel has the same result as the expression() function

' Check if result is NaN
hr1.f = bresult
result_nan = 0 
if (hr1.l & 0x7f800000L) == 0x7f800000L then if hr1.l & 0x007fffffL then result_nan = 1

' Check if expected NaN ; check if PC as well has calculated NaN
hr2.f = bexpect
expect_nan = 0 
if (hr2.l & 0x7f800000L) == 0x7f800000L then if hr2.l & 0x007fffffL then expect_nan = 1
if result_nan && expect_nan then return 

if denorm_supp == 1 then goto f9_label_b

label f9_label_b
' ERROR
' Here we are in the case, that __addsf3 or __mulsf3 or __divsf3 did not return 
' the expected result.

hr1.f = bha
hr2.f = bhb
print "shifted 1 :",hex$((hr1.l&0x007fffff|0x00800000)<<1),hex$((hr2.l&0x007fffff|0x00800000)<<1)
print "shifted 2 :",hex$((hr1.l&0x007fffff|0x00800000)<<2),hex$((hr2.l&0x007fffff|0x00800000)<<2)
print "shifted 3 :",hex$((hr1.l&0x007fffff|0x00800000)<<3),hex$((hr2.l&0x007fffff|0x00800000)<<3)
print "shifted 4 :",hex$((hr1.l&0x007fffff|0x00800000)<<4),hex$((hr2.l&0x007fffff|0x00800000)<<4)

print "************** - not the expected result, ERROR ERROR "
' return 

failures = failures + 1

' return

' Automatically run the function and see how the bad result has been created
f18=bhb
f22=bha
pc=pcstart ' Set next instruction
sp=stackstart

label f9_trace

' p "******************** r25 r17 r24 r23 r22 r13 r12 a=", hex$(r25), hex$(r17), hex$(r24), hex$(r23), hex$(r22), hex$(r13), hex$(r12)
' p "******************** r21 r8  r20 r19 r18 r15 r14 b=", hex$(r21), hex$(r8 ), hex$(r20), hex$(r19), hex$(r18), hex$(r15), hex$(r14)
ss			' Target single step
if pc == __mulsf3_mul_done then p "__mulsf3_mul_done",hex$(r9), hex$(r8), hex$(r7), hex$(r6)

if sp <= stackstart then goto f9_trace
' The target program __addsf3 __divfs3 __mulsf3 did return to the caller level


return 





' ****************************************************************************
' Other helper function
label f4
p "  r18..=",f18,hex$(f18),"  r22..=",f22,hex$(f22)
return 


label f1 ' The help function

print "function f2 = test only testfun"; testfun
print "function f3 = test all 3 subroutines totally"
print "function f4 = print float r18 and r22"
print "function f9 = Perform function ",testfun,"  [call_addsf3=",call_addsf3,"  call_mulsf3=",call_mulsf3," call_divsf3=",call_divsf3,"]"

if testfun == call_addsf3 then bexpect=bha+bhb : print "Check addsf3"
if testfun == call_mulsf3 then bexpect=bha*bhb : print "Check mulsf3"
if testfun == call_divsf3 then bexpect=bha/bhb : print "Check divsf3"

print "function fnc_test_add = test the case bha + bhb"

print "--- from defs.bas :"
gosub defs_help
return


end

include ../../../defs.bas
