
#include <heport.h>
#include <helq.h>
#include <tshar.h>
#include <hevt.h>
#include <hegettim.h>



#if defined( AVR )


void *stk1[16] ;	// 0x80-0x9F
void *stk2[16] ;	// 0xA0-0xBF


// ATMega32 needs 288 Cycles (=17.85 usec) to run 3 empty functions - 2007-05-12

FUNCT void fun1(void)
{
for(;;)
	{
	tsnext("fun1");		
	}
}

FUNCT void fun2(void)
{
for(;;)
	{
	tsnext("fun2");
	}
}

FUNCT int main( int argc, const char **argv )
{
tsopen();		// Clear all tables

tseinri( 1 , fun1, "fun1", stk1, sizeof(stk1) );
tseinri( 2 , fun2, "fun2", stk2, sizeof(stk2) );
for(;;)
	{
	tsnext( "main" );	// run one piece of fun1 and fun2
	}
}


#else

FUNCT void fun1(void);
FUNCT void fun2(void);

bool flag_quit ;

FUNCT int main( int argc, const char **argv )
{
long stk1[200] ;
long stk2[200] ;
int i ;
int iloop ;
ulong startmsec ;

vtopen();

vtcls();
vtprintf( "Started qqtshar.cpp\n" );

// Add both functions into list of active programs

tseinri( 1 , fun1, "fun1", stk1, sizeof(stk1) );
tseinri( 2 , fun2, "fun2", stk2, sizeof(stk2) );
vtprintf( "tseinri called and returned\n" );

i = 7 ;
iloop = 0 ;
startmsec = getmsec();
for(;;)
	{
	if ( flag_quit ) break ;

	tsnext( "main" );	// run one piece of fun1 and fun2
	i += 10 ;
	vtcurpos( 0, 20 );	// Set cursor to x=0 y=20
	vtprintf( "main i = %d     ", i );
	vtcurpos( 0, 21 );
	if ( ++iloop >= 100 )
		{
		iloop = 0 ;
		vtprintf( "%8ld msec", diffmsec(startmsec) );
		startmsec = getmsec();
		}
	vtrefresh();
	}
vtclose();
return 0 ;
}


FUNCT void fun1(void)
{
int i ;
uint zch ;


i = 8 ;
for(;;)				// a loop
	{
	i += 10 ;
	vtcurpos( 0, 0 );
	vtprintf( "fun1 : i = %8d       ", i );
	tsnext( "i-loop" );		// tsnext: run main program and fun2
	if ( vtiskey() )
		{					// A key is pressed
		zch = vtkey() ;
		if ( zch == VTK_ABORT )		// is it the ESCAPE key ?
			flag_quit = true ;
		}
	}
}

FUNCT void fun2(void)
{
int i ;

i = 9 ;
for(;;)
	{
	i += 10 ;
	vtcurpos( 0, 10 );
	vtprintf( "fun2 : i = %8d       ", i );
	tsnext( "i-loop" );
	}
}
#endif
