
#include <heport.h>
#include <helq.h>
#include <hevt.h>
#include <st.h>
#include <simbase.h>
#include <atmel.h>
#include <vtype.h>	// variable values
#include <expressn.h>

// Memory access for exression():
// fun_ubm fun_uwm fun_ulm fun_ubm fun_swm fun_ulm fun_fm fun_dm




extern ulong ulCycles ; // Maschine Cycles

extern ulong maxprocessorram ;

extern sstorage vstorage ;


extern char *txStatusname[8] ;

extern bool bWinAVR ;


#define SP ( ( vstorage.ior.pg.sph << 8 ) | vstorage.ior.pg.spl )


extern uword *ppc ;

extern struct sReguc aReguc[96+1] ;
extern struct sReguw aReguw[17] ;
extern struct sRegul aRegul[1] ;
extern struct sRegf aRegf[1] ;
extern struct sRegd aRegd[2] ;

extern uint nreguc ;
extern uint nregul ;
extern uint nreguw ;
extern uint nregf ;
extern uint nregd ;


extern class CListLine aListLine[ CODEMEM ];
extern uint ncodemem ;		// = CODEMEM, device depend

uchar oldRega ;
bool bTimerStopped ;

ulong maxprocessorram = MAXATMELRAM ;


// Read a HEX file


FUNCT int readprocessorfilehex( void )
{
FILE *fpi ;
char linebu[134] ;
const char *pch ;
char *rvp ;
uword uwAddr ;
uword uwPcode ;
uint iWord ;
ulong ulFilePos ;
ulong ulFilePos1 ;
ulong ulFilePos2 ;
uint ui ;
uchar ucByteCount ;
uint uiLine ;
uchar ucKey ;


fpi = fopen( filename_hex, "r" );
if ( fpi == 0 )
	{
	uprintf( "Cannot read %s", filename_hex );
	return 1 ;
	}
vtprintf( "Reading %s\n", filename_hex );

if ( !bWinAVR )
	{
	for( iWord = 0 ; iWord < ncodemem ; ++iWord )
		{
		aListLine[iWord].bValid = false ;
		}
	}

uiLine = 0 ;
ulFilePos = 0 ;
ulFilePos1 = 0 ;
ulFilePos2 = 0 ;

for(;;)
	{
	ulFilePos2 = ulFilePos1 ;
	ulFilePos1 = ulFilePos ;
	ulFilePos = ftell( fpi );
	uiLine++ ;
	rvp = fgets( linebu, sizeof(linebu), fpi );
	if ( rvp == 0 )
		{				// EOF
		break ;
		}
	// Check if this a code generation line
	for(;;)		// not really a loop !
		{
		if ( strlen( linebu ) < 6 )
			break ;			// Not a Code Generation line
		pch = linebu ;
		if ( *pch != ':' ) break ;
		++pch ;
		if ( asctohx2( &pch, &ucByteCount ) != 0 )
			{
			logvtprintf( "No Bytecount in HEX file line %d\n", uiLine );
			break ;
			}
		if ( ucByteCount == 0 ) break ;
		if ( asctohx4( &pch, &uwAddr ) != 0 )
			break ;
		uwAddr /= 2 ;
		if ( uwAddr >= ncodemem )
			break ;		// Not in Programm memory (behind)
		if ( asctohx2( &pch, &ucKey ) != 0 )
			{
			logvtprintf( "No Key byte in HEX file line %d\n", uiLine );
			break ;
			}
		if ( ucKey != 0 )
			{
			logvtprintf( "Key byte != 0 in HEX file line %d\n", uiLine );
			break ;
			}
		for ( ui = 0 ; ui < (uint)(ucByteCount/2) ; ++ui )
			{
			if ( asctohx4( &pch, &uwPcode ) != 0 )
				break ;

			ucKey = uwPcode >> 8 ;
			uwPcode <<= 8 ;
			uwPcode |= ucKey ;

			if ( bWinAVR == false && aListLine[ uwAddr+ui ].bValid )
				{
				logvtprintf( "multiple code definitions for %XH\n", uwAddr );
				break ;
				}
			tpm[ uwAddr+ui ] = uwPcode ;
			aListLine[ uwAddr+ui ].ulFilePos = ulFilePos ;
			aListLine[ uwAddr+ui ].bValid = true ;
			}
		break ;
		}
	// Check if this a Label definition
	for(;;)		// not really a loop !
		{
		// Check if this a Program Code Line
		if ( strlen( linebu ) < 10 )
			break ;			// Not a Code Generation line
		pch = linebu ;
		if ( asctohx4( &pch, &uwAddr ) != 0 )
			break ;
		if ( uwAddr >= ncodemem )
			break ;		// Not in Programm memory (behind)
		if ( *pch != ' ' )
			break ;
		++pch ;
		pch += 4 ;		// skip the machine code
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch != ' ' )
			break ;
		++pch ;
		// skipped 6 blanks before line number
		pch +=5 ;		// Skip the line number
		if ( *pch != ' ' )
			break ;
		++pch ;
		if ( *pch == ' ' )
			break ;
		if ( *pch == ';' )
			break ;
		// here starts a label
		if ( nLabel < NLabels )
			{
			aLabel[nLabel].uiLV = uwAddr ;
			for ( ui = 0 ; ui < NLL-1 ; ++ui )
				{
				if ( *pch == ' ' || *pch == ':' ) break ;
				aLabel[nLabel].txL[ui] = *pch++ ;
				}
			aLabel[nLabel].txL[ui] = 0 ;
			++nLabel ;
			}
		break ;
		}
	continue ;
	}
comment.Filename( filename_kom );
comment.Read( );
return 0 ;
}


// read a bin file

FUNCT int readprocessorfilebin( void )
{
tfh fdi ;
uint uiPos ;
int rv ;
uint uiX ;
uchar buffer[256] ;
ulong ulFilesize ;

fdi = normopen( filename_bin, O_RDONLY );
if ( fdi < 0 )
	{
	uprintf( "Cannot read %s", filename_bin );
	return 1 ;
	}
vtprintf( "Reading %s\n", filename_bin );


uiPos = 0 ;
for(;;)
	{
	rv = normread( fdi, buffer, sizeof(buffer) );
	if ( rv <= 0 ) break ;
	if ( uiPos >= ncodemem )
		{
		ulFilesize = normlseek( fdi, 0L, 2);
		uprintf( "The binary file is too long, Processor max %u=%XH, the binary file contains %d %X Bytes\n",
					ncodemem, ncodemem, ulFilesize, ulFilesize );
		break ;
		}

	if ( rv > 0 )
		{
		for ( uiX = 0 ; uiX < (uint)rv/2 ; ++uiX )
			{
			if ( uiPos >= ncodemem ) break ;
			tpm[ uiPos ] = ( buffer[uiX*2] ) | (buffer[uiX*2] +1 )<<8 ;
			aListLine[ uiPos ].bValid = true ;
			++uiPos ;
			}
		}
	continue ;
	}


for( uiPos = uiPos ; uiPos < ncodemem ; ++uiPos )
	{
	aListLine[uiPos].bValid = false ;
	}

comment.Filename( filename_kom );
comment.Read( );
return 0 ;
}






// return 0 :
// The "disa" command
// Disassemble one instruction at *padr
FUNCT int disasmvt( uint *padr )
{
Cst xst(80) ;
char *pch ;

if ( *padr >= CODEMEM )
	{
	vtprintf( "ERROR invalid pc %XH\n", *padr );
	return 1 ;
	}
vtprintf( "(%04XH/2=%04X)=%04XH ", *padr*2, *padr, tpm[ *padr ] );
if ( aListLine[ *padr ].bValid == false )
	{
	vtprintf( "disa :Address %XH undefined\n", *padr );
	return 0 ;
	}
xst.DisaAtmel( padr, tpm[ *padr ] ) ;
					// will increment the pointer if there is a two byte instruction

vtprintf( "%s", xst.Start() );		// The decoded instruction
if ( comment.Find( *padr, &pch ) == 0 )
	{								// Any added comment
	vtprintf( "  ;%s", pch );
	}
vtprintf( "\n" );					// The line ir read
return 0 ;
// refresh();
}






/*

FUNCT uchar Reg( uchar ucOffset )
{
uchar retval ;

retval = *( aReguc[ ucOffset ].ptr ) ;

return retval ;
}

*/




FUNCT void processorinit( void )
{
uint uiI ;
// Restart
// Power On Initialise the CPU


vstorage.prediv = 0 ;
for ( uiI = 0 ; uiI < nreguc ; ++uiI )
	{
	*aReguc[uiI].ptr = 0  ;
	}
for ( uiI = 0 ; uiI < nreguw ; ++uiI )
	{
	*aReguw[uiI].ptr = 0 ;
	}
for ( uiI = 0 ; uiI < nregul ; ++uiI )
	{
	*aRegul[uiI].ptr = 0 ;
	}
vstorage.ior.pg.spl = 0 ;
vstorage.ior.pg.sph = 0 ;
// Rewind the prg file and its buffer
rewind_fd_prg();
}


#if BYTEORDER != 1
#error need to rewrite the code below
#endif


FUNCT enum EValuetype general_fun_numeric( 
	class CVarVal *pResult, 
	const char **ppch, 
	uint len )
{
class CVarVal vResult ;
enum EValuetype rv ;
ulong l ;


if ( pResult->eType == Est )
	{
	delete pResult->v.vstX ;
	}
if ( pResult->eType == Et0 )
	{
	delete pResult->v.vchX ;
	}
pResult->eType = EVoid ;

rv = expression( &vResult, ppch ) ;
if ( rv != VALUENUMERIC ) 
	{
	logvterrprintf( "cannot evaluate expression for memory access" );
	return VALUEERROR ;	// Bad type for memory access
	}

if ( **ppch != ')' )
	{
	logvterrprintf( "missing ) after expression" );
	return VALUEERROR ;	// Bad type for memory access
	}

++*ppch ;
l = cnvulong( vResult );	// get the memory addresse
if ( l+len > maxprocessorram ) 
	{
	logvterrprintf( "memory adress %ul too great", l );
	return VALUEERROR ;	// Bad type for memory access
	}
if( len == 1 )		// Euc Eub
	{
	pResult->v.ucX = vstorage.r[l] ;	// read the first byte from processor RAM
	}
if( len == 2 )		// Euw Esw
	{
	pResult->v.uwX = *(uword *)&vstorage.r[l] ;
	}
if( len == 4 )		// Eul Esl Ef
	{				// happyly the avr_gcc and avr_libc uses the same byte order as Intel
	pResult->v.ulX = *(ulong *)&vstorage.r[l] ;
	}
if( len == 8 )		// Ed
	{				// happyly the avr_gcc and avr_libc uses the same byte order as Intel
	pResult->v.dX = *(double *)&vstorage.r[l] ;
	}
return VALUENUMERIC ;
}


// read from processor memory a unsigned character uchar ;
FUNCT enum EValuetype fun_ubm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 1 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Euc ;
return VALUENUMERIC ;
}

// read from processor memory a signed character schar ;
FUNCT enum EValuetype fun_sbm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 1 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Esc ;
return VALUENUMERIC ;
}

FUNCT enum EValuetype fun_uwm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 2 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Euw ;
return VALUENUMERIC ;
}

FUNCT enum EValuetype fun_swm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 2 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Esw ;
return VALUENUMERIC ;
}

FUNCT enum EValuetype fun_ulm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 4 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Eul ;
return VALUENUMERIC ;
}

FUNCT enum EValuetype fun_slm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 4 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Esl ;
return VALUENUMERIC ;
}

FUNCT enum EValuetype fun_fm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 4 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Ef ;
return VALUENUMERIC ;

}

FUNCT enum EValuetype fun_dm( class CVarVal *pResult , const char **ppch )
{
if ( general_fun_numeric( pResult, ppch, 8 ) != VALUENUMERIC ) return VALUEERROR ;
pResult->eType = Ed ;
return VALUENUMERIC ;

}

FUNCT enum EValuetype fun_tm( class CVarVal *pResult , const char **ppch )
{
logvterrprintf( "fun_tm not yet implemented 20070225" );
// need to allocate Cst text
return VALUEERROR ;
}


FUNCT void allCextfunAdd( void )
{
CextfunAdd( fun_ubm, "ubm" );	// unsigned byte from memory
CextfunAdd( fun_sbm, "sbm" );	// signed byte from memory
CextfunAdd( fun_uwm, "uwm" );	// unsigned word from memory
CextfunAdd( fun_swm, "swm" );	// signed word from memory
CextfunAdd( fun_ulm, "ulm" );	// unsigned long from memory
CextfunAdd( fun_slm, "slm" );	// signed long from memory
CextfunAdd( fun_fm,  "fm"  );	// float from Memory
CextfunAdd( fun_dm,  "dm"  );	// double from Memory
CextfunAdd( fun_tm,  "tm"  );	// text from Memory
}
