#define DB_INFO 0
#define DB_ENABLED 0

#include <stdio.h>
#include <heport.h>
#include <helq.h>
#include <helog.h>
#include <hedeb.h>
#include <hevt.h>
#include <hegettim.h>
#include <cfifo.h>
#include <heimath.h>
#include <htmlhelp.h>
#include <simbase.h>

#if SIMPROCESSOR == ATMEL
#include <atmel.h>
#endif

// double dFrequency = 9.6 ;	// MHz
// double dElapsed ;
// Files of this project:
// simbase.cpp : this file only a short entry to the others
// simproc.cpp : common for all processors, interprets all BASIC commands
// expressn.cpp : calculates numeric expressions, as well string expressions as HEX$(1000)
// simatmel.cpp : some ATMEL AVR specific code
// disaatml.cpp : Disassembler for the ATMEL AVR
// disapic.cpp :  Disassembler for the PIC 16F84

int simbase( uint argc, const char **argv );
void debug_dialog( void );	// in simproc.cpp


extern CComment comment ;
bool opt_hexonly = false ;
bool opt_binonly = false ;


extern sstorage *pstorage ;
extern sstorage vstorage ;

extern  bool bWinAVR ;	// Detected in the .lst file

// Invoke the DOS dialog simulation
FUNCT int main( int argc, const char **argv )
{
vtopen();
DBmain( "simbase.dbg" );

#ifdef LINUX
htmlhelpdir( "/home/hjh/home/html/hjh/cc/english/util" );
#else
htmlhelpdir( "C:/home/html/hjh/cc/english/util" );
#endif
simbase(argc, argv);

logclose();
DBexit();
vtclose();
return 0 ;
}




// The DOS dialog simulation
FUNCT int simbase( uint argc, const char **argv )
{
uint iarg ;
const char *pch ;
uint sl ;
uint ifile ;
int rv ;
tfh fd ;
char ch_answer ;


ifile = 0 ;
for ( iarg = 1 ; iarg < argc ; ++iarg )
	{
	pch = argv[iarg] ;
	if ( *pch == '-' )
		{
		++pch ;
		}
	else
		{
		if ( ifile != 0 )
			{
			uprintf( "Too much arguments" );
			return 1 ;
			}
		sl = strlen( pch );
		if ( sl >= sizeof( filename_lst ) - 4 )
			{
			uprintf( "File name too long" );
			return 1 ;
			}
		++ifile ;
		if ( strlen( pch ) >= sizeof( filename_lst ) - 4 )
			{
			uprintf( "File name is too long, is %d, max=%d", strlen(pch), sizeof(filename_lst) - 4 );
			return 1 ;
			}
		if ( regexp( pch, "*.hex" ) )
			{
			opt_hexonly = true ;
			}
		if ( regexp( pch, "*.bin" ) )
			{
			opt_binonly = true ;
			}

		fnamext( filename_lst, sizeof( filename_lst ), pch, "lst" );
		fnamext( filename_map, sizeof( filename_lst ), pch, "map" );
		fnamext( filename_hex, sizeof( filename_hex ), pch, "hex" );
		fnamext( filename_bin, sizeof( filename_hex ), pch, "bin" );
		fnamext( filename_kom, sizeof( filename_hex ), pch, "kom" );
		fnamext( filename_bas, sizeof( filename_hex ), pch, "bas" );

//		fnamext( filename_ini, sizeof( filename_hex ), pch, "ini" );
// Files created by simbase
		fnamext( filename_jrn, sizeof( filename_hex ), pch, "jrn" );
		fnamext( filename_log, sizeof( filename_hex ), pch, "log" );
		}
	}

if ( ifile == 0 )
	{
	uprintf( "Missing Argument Invoke : simbase filename" );
	return 1 ;
	}

if ( ( fd = normopen( filename_log, O_RDONLY ) ) >= 0 )
	{
	normclose( fd );
	ch_answer = ask( "da", "File %s does exist, want to [d]elete or [a]ppend ?", filename_log );
	if ( ch_answer == 'd' )
		{
		unlink( filename_log );
		}
	}
logopen( filename_log );
fpjrn = fopen( filename_jrn, "w" );
if ( fpjrn == 0 )
	{
	uprintf( "Cannot open file [%s] for write\n", filename_jrn );
	return 2 ;
	}

if ( opt_hexonly )			// has been invoked as sim.... name.hex
	{
	rv = readprocessorfilehex();
	}
else if ( opt_binonly )		// has been invoked as sim.... name.bin
	{
	rv = readprocessorfilebin();
	}
else
	{
#if SIMPROCESSOR == ATMEL
	rv = atmel_read_lst(filename_lst,filename_map); // If avr-gcc then the flag bool bWinAVR ; is set
	if ( bWinAVR )
		{
		rv = readprocessorfilehex();	// only there, not in the listing are as well the 
										// initialized constants definitions

		}


#else
	rv = readprocessorfile();
#endif
	}
pstorage = &vstorage ;
debug_dialog();

fclose( fpjrn );
return 0 ;
}




// ----------------------------------------------------------------------------
FUNCT void debug_dialog( void )
{
if ( pstProgbuffer )		// had read a basic program, execute it
	{
	pstProgbuffer->ptxD = 0 ;
	}

allCextfunAdd();


processorinit();
for(;;)
	{
	if ( pstProgbuffer )
		{
		pstProgbuffer->exec_prg();		// execute BASIC
										// BASIC is stopped by the "stop" command
		}
	logflush();
	fflush( fpjrn );
	if ( flagExitSystem ) break ;	// Set by the "System" command
	if ( txDefaultCmd[0] )
		{
		vtprintf( "Cmd [%s] :", txDefaultCmd );
		}
	else
		{
		vtprintf( "Cmd :" );
		}
	if ( vtgetlin( txDialog, sizeof(txDialog) ) != 0 )
		{		// ESC
		strcpy( txDefaultCmd, "" );
		vtnl();
		continue ;
		}
	vtnl();
	if ( txDialog[0] == 0 ) // Has pressed just enter- repeat the default command
		{
		strcpy( txDialog, txDefaultCmd );
		}
	fprintf( fpjrn, "%s\n", txDialog );
	if ( pstProgbuffer )
		{
		pstProgbuffer->ptxD = txDialog ;
		pstProgbuffer->InterpretCommands( "Immediate" );
		}
	// Check if needs next line of prg
	if ( flagExitSystem ) break ;	// Set by the "System" command
	}
comment.WriteIfChanged( );
}


